---
type: blog
title: Building Automotive Linux for Edge and Cloud
description: Building an Automotive Embedded Linux Image for Edge and Cloud Using Arm-based Graviton Instances, Yocto Project, and SOAFEE
date: 2022-06-17
banner:
  background: banner/banner2.jpg
---

import LinkButton from '@/components/linkbutton';
import Image from 'next/legacy/image'
import Workflow from './images/validation_workflow.png'

# Building an Automotive Embedded Linux Image for Edge and Cloud Using Arm-based Graviton Instances, Yocto Project, and SOAFEE

Embedded software developers in the automotive industry have used a traditional embedded development methodology that has been largely unchanged for decades. The embedded target system that the software is being written for is by nature resource constrained with limited memory, compute, and input/output capacity. Additionally, embedded development systems are often expensive and a scarce commodity for development teams working on brand new [electronic control units](https://en.wikipedia.org/wiki/Electronic_control_unit) (ECUs) and [system-on-chip](https://en.wikipedia.org/wiki/System_on_a_chip) (SoC) architectures. This scarcity has become further apparent with the recent global chip shortages in the automotive industry.

This means software developers avoid developing software directly on the embedded platform itself and instead rely on developing software on a powerful development machine or host. Compilers and toolchains used to create executable software for development and testing on the host machine cannot be used directly for deployment on the embedded target. Many times, the target-embedded operating system (OS) itself cannot be used on the host machine. Developers rely on cumbersome OS emulation tools on their host machine and the process of cross-compiling, which uses a special compiler to create executable code for the target system. Once that code is on the development system, a final integration and validation testing can be performed, but scaling is limited to the number of physical hardware platforms. Typical development, integration, and validation workflows for embedded systems look like the following today:

<Image src={Workflow} />

This blog will introduce a building block toward a novel automotive-software development concept that helps developers create, test, and debug natively compiled software using the cloud, greatly simplifying this workflow. This concept is often referred to as environmental parity, which you can learn more about in [this whitepaper from Arm and Amazon Web Services](https://armkeil.blob.core.windows.net/developer/Files/pdf/white-paper/arm-aws-edge-environmental-parity-wp.pdf) (AWS), as well as in Kevin Hoffman’s book, [Beyond the Twelve-Factor App](https://www.oreilly.com/library/view/beyond-the-twelve-factor/9781492042631/).

> The purpose of…environment parity is to give your team and your entire organization the confidence that the application will work everywhere.

<cite>Kevin Hoffman</cite>

Environmental parity is a major element in achieving the objective of cloud-native-software-defined vehicles.

<LinkButton url="https://aws.amazon.com/blogs/industries/building-an-automotive-embedded-linux-image-for-edge-using-arm-graviton-yocto-project-soafee/">Read the blog</LinkButton>
